import platform
import random
import subprocess
import time

import loguru
import requests
import json
import tls_client
from bson import ObjectId
import hashlib
from pymongo import MongoClient
from loguru import logger




def md5(text):
    m = hashlib.md5()
    m.update(text.encode())
    return m.hexdigest()

# 连接MongoDB数据库
client = MongoClient('mongodb://lcc-spider:JIUsfhiad&^@18.144.59.80:27017/?authSource=admin&directConnection=true')
db = client.env

# 查询所有文档
# result = db.env_shape.find({'env.navigatorparams.useragent':{'$regex': 'Firefox'}})
# data = {str(x['_id']): x['env'] for x in result}
# print(result)
# with open('ff.json', 'w', encoding='utf-8') as f:
#     f.write(json.dumps(data))
with open('env.json', 'r', encoding='utf-8') as f:
    data = json.loads(f.read())
envs = data.keys()


# session = requests.session()
headers = {
    "Host": "jbrest.jetblue.com",
    "application-channel": "Desktop_Web",
    "user-agent": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/114.0.0.0 Safari/537.36",
    "booking-application-type": "NGB",
    "content-type": "application/json",
    "accept": "application/json",
    "origin": "https://www.jetblue.com",
    "accept-language": "en-US,en;q=0.9,zh-CN;q=0.8,zh;q=0.7"
}
# tlss = [ 'chrome_103', 'chrome_104', 'chrome_105', 'chrome_106',
#         'firefox_102', 'firefox_104'
        # Opera --> opera_89, opera_90
      # 'safari_15_3', 'safari_15_6_1', 'safari_16_0',
      #   'safari_ios_15_5', 'safari_ios_15_6', 'safari_ios_16_0',
      #  'safari_ios_15_6'
      #   ]
lastHash = ''
usedTime = 10
success = 0
selectId = random.choice(list(envs))
code = open('src.js', 'r', encoding='utf-8').read()
code1 = open('js_dom_run.js', 'r', encoding='utf-8').read()
for i in range(100):
    proxy = f'http://unfflcc:76cc14-47b8dd-1f8ace-827836-0c740e@usa.rotating.proxyrack.net:{int(random.randint(10000, 11149))}'
    # proxy = f'http://unfflcc:76cc14-47b8dd-1f8ace-827836-0c740e@198.147.25.26:{int(random.randint(10000, 11149))}'
    proxy = 'http://user-unifflcc-region-us:q39CEBTs5A5YQXor@pr.roxlabs.cn:4600'
    if platform.uname().system == 'Darwin':
        proxy = 'http://127.0.0.1:7890'
    tlsV = f'chrome_{random.randint(105, 113)}'
    tlsV = 'chrome_114'
    session = tls_client.Session(tlsV)
    session.proxies = {
        'http': proxy,
        'https': proxy,
    }
    # selectId = 'a74b38e7115cf4d1b1f6976c'
    c = session.get('https://www.jetblue.com/js/src/jb-74873.js').text
    m5 = md5(c)
    if m5 != lastHash and usedTime > 2:
        lastHash = m5
        usedTime = 0
        logger.debug('js变化')
        selectId = random.choice(list(envs))
        code = open('src.js', 'r', encoding='utf-8').read()
        code1 = open('js_dom_run.js', 'r', encoding='utf-8').read()
        with open('src_run1.js', 'w', encoding='utf-8') as f:
            f.write(code + '\n\n' + c)
        # with open('js_dom_run1.js', 'w', encoding='utf-8') as f:
        #     f.write(code1 + '\n\n' + c)`
    t1 = time.time()
    # r = requests.get('http://127.0.0.1:5000/getinfo').json()['message']
    # r = requests.get('http://127.0.0.1:3001').json()
    # p = subprocess.Popen(['node', 'js_dom_run.js', selectId], stdin=subprocess.PIPE, stdout=subprocess.PIPE,
    p = subprocess.Popen(['node', 'src_run.js', selectId, '11'], stdin=subprocess.PIPE, stdout=subprocess.PIPE,
                         stderr=subprocess.PIPE)


    output, err = p.communicate(timeout=10)
    tmp = ''
    if p.returncode == 0:
        tmp = output.decode().split('\n')[-2]
    else:
        raise Exception("执行js失败")
    r = json.loads(tmp)
    res = db.env_shape.update_one(
        {'_id': ObjectId(selectId)},
        {"$inc": {"used": 1}}
    )
    usedTime += 1

    headers.update(r)
    # headers = r
    logger.info(f"success:{success}  {(time.time() - t1) *1000:.3f}ms {len(headers['X-1ItxWO9i-a'.lower()])} {selectId} {headers['user-agent']}")
    url = "https://jbrest.jetblue.com/lfs-rwb/outboundLFS"
    data = {
        "tripType": "oneWay",
        "from": "LAS",
        "to": "BOS",
        "depart": "2023-05-10",
        "cabin": "economy",
        "refundable": False,
        "dates": {
            "before": "3",
            "after": "3"
        },
        "pax": {
            "ADT": 1,
            "CHD": 0,
            "INF": 0,
            "UNN": 0
        },
        "redempoint": False,
        "pointsBreakup": {
            "option": "",
            "value": 0
        },
        "isMultiCity": False,
        "isDomestic": False
    }

    # session = requests.Session()

    response = session.post(url, headers=headers, json=data)
    logger.info(f'tls:{tlsV} proxy:{proxy}  res:: {response.status_code}')

    # print(response.text)
    if response.status_code != 403:
        res = db.env_shape.update_one(
            {'_id': ObjectId(selectId)},
            {"$inc": {"success": 1}}
        )
        # proxy = requests.post('http://ymx-lcc.unififi.com/proxy/get-proxy', json={
        #     'type':'headerB6'
        # })

        uri = 'http://ymx-lcc.unififi.com/header/add'
        proxy = f'http://unfflcc:76cc14-47b8dd-1f8ace-827836-0c740e@usa.rotating.proxyrack.net:{int(random.randint(10000, 11149))}'
        r = requests.post(uri, json={
            'brush_fromto': 'LAS-BOS',
            'brush_fromdate': '2023-05-26',
            'brush_header': headers,
            'brush_proxy':proxy,
            'brush_mode':'shopping',
            'brush_name':'js',
            'brush_type':'headerB6',
        })
        success+=1
        logger.success(f'添加成功 {success}')
    # time.sleep(3)
